.text
.org 0
          /* parametro in R0: puntatore alla lista di byte da impaccare */
          /* parametro in R1: numero pari di byte da impaccare */
          /* parametro in R2: puntatore alla lista di byte di ritorno */
PACKBCD:  STMFD SP!, {R3-R5,R14} /* impila i registri di lavoro e LR */
          MOV   R1, R1,LSR #1 /* dimezza il numero di byte per il ritorno */
PACK:     LDRB  R3, [R0],#1   /* carica il primo byte, incrementa puntatore */
          MOV   R3, R3,LSL #4 /* scorrimento a sinistra di 4 bit */
          LDRB  R4, [R0],#1   /* carica il secondo byte, incrementa puntatore */
          AND   R4, R4, #0xF  /* azzerane i 4 bit di sinistra */
          ORR   R5, R4, R3    /* concatena le due cifre BCD */
          STRB  R5, [R2],#1   /* memorizza il risultato e aggiorna puntatore */
          SUBS  R1, R1, #1    /* decrementa il contatore delle cifre */
          BGT   PACK          /* reitera se la lista non è completa */
          LDMFD SP!, {R3-R5,R15} /* ripristino dei registri e rientro */
.global PACKBCD
.end
