.intel_mnemonic
.intel_syntax noprefix
.text
.org 0
          /* parametro in ESI: puntatore alla coppia di byte da impaccare */
          /* parametro in EDI: puntatore al byte impaccato */
PACK2:    PUSH  EAX           /* impila i registri di lavoro */
          PUSH  EBX
          MOV   AL, [ESI]     /* carica il primo byte */
          SHL   AL, 4         /* scorrimento a sinistra di 4 bit */
          MOV   BL, [ESI + 1] /* carica il secondo byte  */
          AND   BL, 0x0F      /* azzerane i 4 bit di sinistra */
          OR    AL, BL        /* concatena le due cifre BCD */
          MOV   [EDI], AL     /* scrivi risultato in memoria */
          ADD   ESI, 2        /* aggiorna puntatore alla coppia di byte */ 
          INC   EDI           /* aggiorna puntatore al byte di ritorno */ 
          POP   EBX           /* spila e ripristina i registri di lavoro */
          POP   EAX
          RET 
.global PACK2
.end
