.text
.org 0
          /* parametro in r2: puntatore alla lista di byte da impaccare */
          /* parametro in r3: numero pari di byte da impaccare */
          /* parametro in r4: puntatore alla lista di byte di ritorno */
PACKBCD:  subi  sp, sp, 12    /* impila i registri di lavoro */
          stw   r5, 8(sp)
          stw   r6, 4(sp)
          stw   r7, (sp)
          srai  r3, r3, 1     /* dimezza il numero di byte per il ritorno */
PACK:   
          ldb   r5, (r2)      /* carica il primo byte */
          slli  r5, r5, 4     /* scorrimento a sinistra di 4 bit */
          ldb   r6, 1(r2)     /* carica il secondo byte  */
          andi  r6, r6, 0xF   /* azzerane i 4 bit di sinistra */
          or    r7, r6, r5    /* concatena le due cifre BCD */
          stb   r7, (r4)      /* scrivi risultato in memoria */
          addi  r2, r2, 2     /* aggiorna il puntatore alla cifra successiva */
          addi  r4, r4, 1     /* aggiorna puntatore ai byte di ritorno */ 
          subi  r3, r3, 1     /* decrementa il contatore delle cifre */
          bgt   r3, r0, PACK  /* reitera se la lista non è completa */
          ldw   r7, (sp)      /* spila i registri */
          ldw   r6, 4(sp)
          ldw   r5, 8(sp)
          addi  sp, sp, 12    /* ripristina il puntatore alla pila */
          ret                 /* rientro */
.global PACKBCD
.end
